public class UE7Aufgabe15 {

	// Testprogramm
	public static void main(String[] args) {
		int[] array1 = { 1, 3, 4, 4, 5 };
		int[] array2 = { 2, 3, 3, 5, 9 };

		int[] erg = mischen2(array1, array2);
		for (int i = 0; i < erg.length; i++) {
			System.out.print(erg[i] + " ");
		}
		System.out.println();

	}

	/**
	 * Die Funktion mischt die beiden uebergebenen Arrays zu einem neuen Array;
	 * Vorbedingung: Die beiden uebergebenen Arrays sind sortiert.
	 * Nachbedingung: Das gelieferte Array enthaelt alle Elemente der beiden
	 * uebergebenen Arrays und ist sortiert. Die beiden uebergebenen Arrays
	 * bleiben unveraendert.
	 *
	 * @param menge1
	 *            sortiertes Array (!= null)
	 * @param menge2
	 *            sortiertes Array (!= null)
	 * @return sortiertes Array mit allen Elemente der uebergebenen Arrays
	 */
	static int[] mischen(int[] menge1, int[] menge2) {
		int[] erg = new int[menge1.length + menge2.length];
		int index1 = 0;
		int index2 = 0;
		for (int i = 0; i < erg.length; i++) {
			if (index1 >= menge1.length) {
				erg[i] = menge2[index2];
				index2++;
			} else if (index2 >= menge2.length) {
				erg[i] = menge1[index1];
				index1++;
			} else if (menge1[index1] <= menge2[index2]) {
				erg[i] = menge1[index1];
				index1++;
			} else {
				erg[i] = menge2[index2];
				index2++;
			}
		}
		return erg;
	}

	static int[] mischen2(int[] menge1, int[] menge2) {
		int i = 0, j = 0, k = 0;
		int[] erg = new int[menge1.length + menge2.length];

		while (i < menge1.length && j < menge2.length) {
			if (menge1[i] < menge2[j]) {
				erg[k++] = menge1[i++];
			} else {
				erg[k++] = menge2[j++];
			}
		}

		while (i < menge1.length) {
			erg[k++] = menge1[i++];
		}
		while (j < menge2.length) {
			erg[k++] = menge2[j++];
		}

		return erg;
	}
}
