public class UE7Aufgabe30 {

	/**
	 * kopiert die Werte eines beliebigen 2-dimensionalen Array Zeile fr Zeile
	 * in ein neu erzeugtes 1-dimensionales Array
	 * 
	 * @param werte
	 *            beliebiges 2-dimensionales Array
	 * @return "platt gemachtes" 1-dimensionales Array
	 */
	public static int[] plattmachen(int[][] werte) {

		// Sonderfall: werte == null
		if (werte == null) {
			return null;
		}

		// Laenge des Ergebnis-Arrays bestimmen
		int laenge = 0;
		for (int i = 0; i < werte.length; i++) {
			if (werte[i] != null) { // Sonderfall!
				laenge += werte[i].length;
			}
		}

		// Ergebnis-Array erzeugen
		int[] ergebnis = new int[laenge];

		// Ergebnis-Array fuellen
		int index = 0;

		// alle Zeilen durchlaufen
		for (int i = 0; i < werte.length; i++) {
			if (werte[i] != null) { // Sonderfall!

				// alle Spalten pro Zeile durchlaufen
				for (int j = 0; j < werte[i].length; j++) {
					ergebnis[index++] = werte[i][j];
				}
			}
		}

		// Ergebnis-Array liefern
		return ergebnis;
	}

	// Testprogramm
	public static void main(String[] args) {
		int[][] werte = { { 1, 2, 3 }, { 4, 5 }, { 6, 7, 8, 9 }, { 10 }, {},
				null, { 11, 12, 13 } };
		int[] pwerte = plattmachen(werte);
		print(pwerte);
	}

	static void print(int[] werte) {
		for (int i = 0; i < werte.length; i++) {
			System.out.print(werte[i] + ", ");
		}
		System.out.println();
	}

}
