public class UE7Aufgabe54 {

	public static void main(String[] args) {
		int[][] matrix = { { 1, 3, 8, 4, 6, 6 }, { 4, 9, 7, 9, 1, 5 },
				{ 2, 2, 6, 5, 4, 1 }, { 3, 3, 7, 3, 3, 4 },
				{ 1, 2, 6, 7, 8, 9 } };
		System.out.println(enthaeltBZahl(matrix));

	}

	static boolean enthaeltBZahl(int[][] matrix) {
		// alle Zeilen durchsuchen
		for (int r = 0; r < matrix.length; r++) {

			// suche groesste Zahl der Reihe
			int gSpaltenIndex = 0;
			for (int s = 1; s < matrix[r].length; s++) {
				if (matrix[r][s] > matrix[r][gSpaltenIndex]) {
					gSpaltenIndex = s;
				}
			}

			// ist kleinste Zahl der Spalte?
			boolean kleinerGefunden = false;
			for (int r2 = 0; r2 < matrix.length; r2++) {
				if (matrix[r2][gSpaltenIndex] < matrix[r][gSpaltenIndex]) {
					kleinerGefunden = true;
				}
			}
			if (!kleinerGefunden) {
				return true; // B-Zahl gefunden
			}
		}
		return false; // keine B-Zahl gefunden
	}
}
