public class UE7Aufgabe57 {

	public static void main(String[] args) {
		char[] ausdruck1 = { '1', '1', '3', '+', '2', '3' };
		print(ausdruck1);
		char[] ausdruck2 = { '2', '8', '-', '1', '0', '/', '5', '*', '7', '%',
				'9' };
		print(ausdruck2);
	}

	static void print(char[] ausdruck) {
		System.out.print(ausdruck); // geht auch
		System.out.print("=");
		System.out.println(berechne(ausdruck));

	}

	static int berechne(char[] zeichen) {
		if (zeichen == null || zeichen.length == 0) {
			return 0;
		}
		int erg = 0;
		char op = 0;
		int zahl = 0;
		for (int z = 0; z < zeichen.length; z++) {
			if (ziffer(zeichen[z])) {
				zahl = zahl * 10 + (zeichen[z] - '0');
			} else { // Operator
				if (op == 0) { // erster Operator
					erg = zahl;
				} else { // berechne Ausdruck
					erg = berechne(erg, op, zahl);
				}
				// Operator merken
				op = zeichen[z];
				zahl = 0;
			}
		}

		// letzte Zahl verarbeiten
		erg = berechne(erg, op, zahl);
		return erg;
	}

	static int berechne(int zahl1, char op, int zahl2) {
		switch (op) {
		case '+':
			return zahl1 + zahl2;
		case '-':
			return zahl1 - zahl2;
		case '*':
			return zahl1 * zahl2;
		case '/':
			return zahl1 / zahl2;
		case '%':
			return zahl1 % zahl2;
		}
		return 0;
	}

	static boolean ziffer(char c) {
		return '0' <= c && c <= '9';
	}

}
