public class UE7Aufgabe58 {

	// Testprogramm
	public static void main(String[] args) {
		String eingabe = IO.readString("Text: ");
		int schluessel = IO.readInt("Schluessel: ");

		String verschluesselt = verschluesseln(eingabe, schluessel);
		System.out.println("Verschluesselt: " + verschluesselt);

		String entschluesselt = entschluesseln(verschluesselt, schluessel);
		System.out.println("Entschluesselt: " + entschluesselt);
	}

	static String verschluesseln(String klartext, int schluessel) {
		char[][] matrix = new char[(klartext.length() + schluessel - 1)
				/ schluessel][schluessel];
		for (int i = 0; i < klartext.length(); i++) {
			matrix[i / schluessel][i % schluessel] = klartext.charAt(i);
		}

		String geheimtext = "";
		for (int s = 0; s < schluessel; s++) {
			for (int r = 0; r < matrix.length; r++) {
				if (matrix[r][s] != 0) {
					geheimtext += matrix[r][s];
				} else {
					geheimtext += " ";
				}
			}

		}
		return geheimtext;
	}

	static String entschluesseln(String geheimtext, int schluessel) {
		char[][] matrix = new char[geheimtext.length() / schluessel][schluessel];
		for (int i = 0; i < geheimtext.length(); i++) {
			matrix[i % (geheimtext.length() / schluessel)][i
					/ (geheimtext.length() / schluessel)] = geheimtext
					.charAt(i);
		}
		String erg = "";
		for (int r = 0; r < matrix.length; r++) {
			for (int s = 0; s < matrix[r].length; s++) {
				erg += matrix[r][s];
			}
		}
		return erg;
	}
}
