// http://www.logicgamesonline.com/lightsout/
// https://en.wikipedia.org/wiki/Lights_Out_(game)
/*
O---O	OO---
-O-O-	O--O-
OOO--	-O---
--OOO	---O-
O-OO-	----O
-OO-O	O----
OO-OO	--O--
*/
public class UE7Aufgabe72 {

	public static void main(String[] args) {
		final boolean ON = true;
		boolean[][] lights = new boolean[5][5];
		for (int r = 0; r < lights.length; r++) {
			for (int c = 0; c < lights[r].length; c++) {
				lights[r][c] = ON;
			}
		}

		boolean oneLightOn;
		do {
			System.out.print(' ');
			for (int c = 0; c < lights[0].length; c++) {
				System.out.print(c);
			}
			System.out.println();
			for (int r = 0; r < lights.length; r++) {
				System.out.print(r);
				for (int c = 0; c < lights[r].length; c++) {
					if (lights[r][c]) {
						System.out.print('*');
					} else {
						System.out.print('.');
					}
				}
				System.out.println();
			}

			int row = IO.readInt("Row: ");
			while (row < 0 || row >= lights.length) {
				row = IO.readInt("Invalid Row! Row: ");
			}

			int col = IO.readInt("Column: ");
			while (col < 0 || col >= lights[0].length) {
				col = IO.readInt("Invalid Column! Column: ");
			}

			lights[row][col] = !lights[row][col];
			if (row - 1 >= 0)
				lights[row - 1][col] = !lights[row - 1][col];
			if (col - 1 >= 0)
				lights[row][col - 1] = !lights[row][col - 1];
			if (row + 1 < lights.length)
				lights[row + 1][col] = !lights[row + 1][col];
			if (col + 1 < lights[0].length)
				lights[row][col + 1] = !lights[row][col + 1];

			oneLightOn = false;
			for (int r = 0; r < lights.length; r++) {
				for (int c = 0; c < lights[r].length; c++) {
					if (lights[r][c]) {
						oneLightOn = true;
						break;
					}
				}
			}
		} while (oneLightOn);
	}

}
