
public class UE7Aufgabe88 {

	public static void main(String[] args) {
		// gegeben beliebige rechteckige Matrix mit genau vier 1en
		int[][] area = { 
				 { 0, 0, 1, 0, 0, 1, 0, 0, 0, 0 }, 
				 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
				 { 0, 0, 1, 0, 0, 1, 0, 0, 0, 0 }, 
				 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 } 
				};
		if (containsRectangle(area)) {
			System.out.println("enthaelt ein 1er-Rechteck");
		} else {
			System.out.println("enthaelt kein 1er-Rechteck");
		}
	}

	// sucht im Gebiet nach der oberen linken 1
	static boolean containsRectangle(int[][] area) {
		for (int r = 0; r < area.length; r++) {
			for (int c = 0; c < area[0].length; c++) {
				if (area[r][c] == 1) {
					return checkField(area, r, c);
				}
			}
		}
		return false;
	}

	private static boolean checkField(int[][] area, int rowTop, int colLeft) {
		// schaut ob weiter rechts in der Reihe noch eine 1 ist
		int colRight = -1;
		for (int c = colLeft + 1; c < area[0].length; c++) {
			if (area[rowTop][c] == 1) {
				colRight = c;
				break;
			}
		}
		if (colRight == -1) {
			return false; // weiter rechts ist keine 1
		}
		
		// schaut, ob weiter unten in der Spalte noch eine 1 ist
		int rowBottom = -1;
		for (int r = rowTop + 1; r < area.length; r++) {
			if (area[r][colLeft] == 1) {
				rowBottom = r;
				break;
			}
		}
		if (rowBottom == -1) {
			return false; // weiter unten ist keine 1
		}
		
		// schaut, ob die berechnete rechte untere Ecke mit einer 1 belegt ist; 
		// genau dann gibt es ein Rechteck
		return area[rowBottom][colRight] == 1;
	}

}
