public class UE7Aufgabe5 {

	public static void main(String[] args) {
		int zeilenzahl = 0;
		do {
			zeilenzahl = IO.readInt("Anzahl Zeilen bzw. Spalten: ");
		} while (zeilenzahl % 2 == 0 || zeilenzahl <= 2 || zeilenzahl > 99);
		int[][] quadrat = erzeugeQuadrat(zeilenzahl);
		ausgabe(quadrat);
	}

	static int[][] erzeugeQuadrat(int zeilen) {
		// Erzeugung des Feldes
		int[][] quadrat = new int[zeilen][zeilen];

		// Initialisierung des Feldes mit Nullen
		for (int z = 0; z < quadrat.length; z++) {
			for (int s = 0; s < quadrat[z].length; s++) {
				quadrat[z][s] = 0;
			}
		}

		// Anzahl an Feldern berechnen
		int felder = zeilen * zeilen;

		// Platzieren der 1
		int spalte = zeilen / 2;
		int zeile = spalte + 1;
		quadrat[zeile][spalte] = 1;

		// Erzeugungsalgorithmus
		for (int zahl = 2; zahl <= felder; zahl++) {
			zeile = nachfolger(zeile, zeilen);
			spalte = nachfolger(spalte, zeilen);
			while (quadrat[zeile][spalte] > 0) {
				zeile = nachfolger(zeile, zeilen);
				spalte = vorgaenger(spalte, zeilen);
			}
			quadrat[zeile][spalte] = zahl;
		}

		return quadrat;

	}

	static int nachfolger(int zeile, int zeilenzahl) {
		if (zeile < zeilenzahl - 1)
			return zeile + 1;
		else
			return 0;
	}

	static int vorgaenger(int zeile, int zeilenzahl) {
		if (zeile > 0)
			return zeile - 1;
		else
			return zeilenzahl - 1;
	}

	static void ausgabe(int[][] quadrat) {
		for (int z = 0; z < quadrat.length; z++) {
			for (int s = 0; s < quadrat[z].length; s++) {
				if (quadrat[z][s] <= 9) {
					System.out.print("  " + quadrat[z][s]);
				} else {
					System.out.print(" " + quadrat[z][s]);
				}
			}
			System.out.println();
		}
	}

}
