public class UE7Aufgabe60 {

	public static void main(String[] args) {

		// Initialisierung
		int anzahl = IO.readInt("Anzahl an Feldern (> 0)?");
		while (anzahl <= 0) {
			anzahl = IO.readInt("Fehlerhafte Anzahl! Anzahl an Feldern (> 0)?");
		}
		int[] felder = new int[anzahl];
		print(felder);
		int spieler = 1;
		
		// Spielablauf
		while (!spielende(felder)) {
			System.out.println("Spieler " + spieler + " ist am Zug!");
			
			// naechsten korrekten Spielzug einlesen
			int feld1 = ermitteleSpielzug(felder);
			
			// Spielzug ausfuehren
			felder[feld1] = spieler;
			felder[feld1+1] = spieler;
			
			print(felder);

			// Spielerwechsel
			spieler = spieler % 2 + 1;
		}
		System.out.println("Spieler " + spieler + " hat verloren!");
	}
	


	// Ausgabe des Feldes
	static void print(int[] felder) {
		System.out.print("Feld: ");
		for (int wert : felder) {
			if (wert == 0) {
				System.out.print(".");
			} else {
				System.out.print(wert);
			}
		}
		System.out.println();
	}
	
	// korrekten gueltigen Spielzug erfragen
	static int ermitteleSpielzug(int[] felder) {
		int feld = IO.readInt("Index des linken Feldes?");
		while (feld < 0 || feld >= felder.length-1 || felder[feld] != 0 || felder[feld+1] != 0) {
			feld = IO.readInt("Ungueltiges Feld! Index des linken Feldes?");
		}
		return feld;
	}
	
	// Spielende ueberpruefen
	static boolean spielende(int[] felder) {
		for (int i=0; i<felder.length-1; i++) {
			if (felder[i] == 0 && felder[i+1] == 0) {
				return false;
			}
		}
		return true;
	}
}
