
public class UE7Aufgabe76 {

	public static void main(String[] args) {
		int[] leapYears = getLeapYears(1860, 2030);
		for (int year : leapYears) {
			System.out.println(year);
		}
	}

	static int[] getLeapYears(int from, int to) {
		int number = 0;
		for (int year = from; year <= to; year++) {
			number += isLeapYear(year) ? 1 : 0;
		}
		int[] leapYears = new int[number];
		int y = 0;
		for (int year = from; year <= to; year++) {
			if (isLeapYear(year)) {
				leapYears[y++] = year;
			}
		}
		return leapYears;
	}

	static boolean isLeapYear(int year) {
		return year % 4 == 0 && (year % 100 != 0 || year % 400 == 0);
	}

	public static boolean isLeapYear2(int year) {
		if (year % 4 == 0) {
			if (year % 100 == 0 && year % 400 == 0) {
				return true;
			} else {
				if (year % 100 == 0 && year % 400 != 0) {
					return false;
				}
			}
			return true;
		}
		return false;
	}

}
